<template>
    <div class="user-profile__info">
        <div class="user-profile__info-section-title d-flex align-content-center align-items-center">
            {{ user.name }}
            <a :href="settingsRoute" class="edit-profile-block">
                <i>
                    <svg width="18" height="15" viewBox="0 0 18 15" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1.69478 11.3369L0.432779 13.8776C0.396408 13.9508 0.387505 14.031 0.407172 14.1082C0.426839 14.1854 0.474213 14.2563 0.543419 14.3121C0.612626 14.3678 0.700622 14.406 0.796498 14.4218C0.892375 14.4377 0.991915 14.4305 1.08278 14.4012L4.23778 13.3846C4.74075 13.2226 5.19765 12.9801 5.58078 12.6717L16.4998 3.875C16.8976 3.55453 17.1211 3.11988 17.1211 2.66667C17.1211 2.21345 16.8976 1.7788 16.4998 1.45833C16.102 1.13786 15.5624 0.957825 14.9998 0.957825C14.4372 0.957825 13.8976 1.13786 13.4998 1.45833L2.57978 10.255C2.19689 10.5636 1.89581 10.9317 1.69478 11.3369V11.3369Z" fill="#7D2AEB"/>
                    </svg>
                </i>
            </a>
        </div>
        <div class="user-profile__info-phone">+{{ user.phone }}</div>
        <div class="user-profile__info-stats">
            <button ref="profileUp" type="button" v-on:click="upProfile" :class="upProfileButtonClass" :disabled="! upProfileButtonIsActive">
                <i>
                    <svg class="upProfile-icon" width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <path fill-rule="evenodd" clip-rule="evenodd" d="M10 0.25C4.615 0.25 0.25 4.615 0.25 10C0.25 15.385 4.615 19.75 10 19.75C15.385 19.75 19.75 15.385 19.75 10C19.75 4.615 15.385 0.25 10 0.25ZM10.53 5.72C10.3894 5.57955 10.1988 5.50066 10 5.50066C9.80125 5.50066 9.61063 5.57955 9.47 5.72L6.47 8.72C6.39631 8.78866 6.33721 8.87146 6.29622 8.96346C6.25523 9.05546 6.23318 9.15477 6.23141 9.25548C6.22963 9.35618 6.24816 9.45621 6.28588 9.5496C6.3236 9.64299 6.37974 9.72782 6.45096 9.79904C6.52218 9.87026 6.60701 9.9264 6.7004 9.96412C6.79379 10.0018 6.89382 10.0204 6.99452 10.0186C7.09522 10.0168 7.19454 9.99477 7.28654 9.95378C7.37854 9.91279 7.46134 9.85369 7.53 9.78L9.25 8.06V13.75C9.25 13.9489 9.32902 14.1397 9.46967 14.2803C9.61032 14.421 9.80109 14.5 10 14.5C10.1989 14.5 10.3897 14.421 10.5303 14.2803C10.671 14.1397 10.75 13.9489 10.75 13.75V8.06L12.47 9.78C12.5387 9.85369 12.6215 9.91279 12.7135 9.95378C12.8055 9.99477 12.9048 10.0168 13.0055 10.0186C13.1062 10.0204 13.2062 10.0018 13.2996 9.96412C13.393 9.9264 13.4778 9.87026 13.549 9.79904C13.6203 9.72782 13.6764 9.64299 13.7141 9.5496C13.7518 9.45621 13.7704 9.35618 13.7686 9.25548C13.7668 9.15477 13.7448 9.05546 13.7038 8.96346C13.6628 8.87146 13.6037 8.78866 13.53 8.72L10.53 5.72Z" />
                    </svg>
                </i>
                {{ upProfileButtonText }}
            </button>
            <!-- <span class="stat-view text-info-empty">Просмотры профиля: <b>{{ user.views_total }}</b></span> -->
        </div>
        <div class="user-profile__info-stats-text">
            Раз в 15 минут вы можете бесплатно поднять свой профиль. Это сделает ваше предложение заметнее.
        </div>
    </div>
</template>

<script>
import moment from 'moment';
import {correctWordEnding} from "@utils/helpers";

export default {
    props: {
        user: Object,
        settingsRoute: String,
    },
    data() {
        return {
            userLastProfileUpAt: this.user.last_profile_up_at ? new moment(this.user.last_profile_up_at) : null,
        }
    },
    computed: {
        upProfileButtonIsActive() {
            const current = new moment();

            return this.userLastProfileUpAt === null || this.userLastProfileUpAt <= current.subtract(2, 'minutes');
        },
        upProfileButtonText() {
            const current = new moment();

            let lostMinutes = 2 - current.diff(this.userLastProfileUpAt, 'minutes');

            if (this.userLastProfileUpAt === null || lostMinutes <= 0) {
                return 'Поднять бесплатно';
            }

            return 'Поднять бесплатно через ' + lostMinutes + ' ' + correctWordEnding(lostMinutes, ['минуту', 'минуты', 'минут']);
        },
        upProfileButtonClass() {
            return ! this.upProfileButtonIsActive ? 'bg-secondary' : '';
        },
    },
    methods: {
        async upProfile() {
            await axios
                .get('/api/profile/up/')
                .then(result => {
                    this.userLastProfileUpAt = result.data.user.last_profile_up_at;
                })
                .catch(error => {

                })
            ;
        },
    },
}
</script>
